using System;
using System.ComponentModel;
using System.Windows.Forms;
public class ExtendedNumericUpDown : NumericUpDown {
	public class UpDownEventArgs : EventArgs {
		private bool handled = false;
		private readonly bool up;
		internal UpDownEventArgs(bool up) {
			this.up = up;
		}
		public bool Handled {
			get {
				return handled;
			}
			set {
				handled = value;
			}
		}
		public bool Up {
			get {
				return up;
			}
		}
	}
	public delegate void UpDownEventHandler(object sender, UpDownEventArgs e);
	[Category("Action")]
	[Description("Up/Down{^ꂽƂɔ܂B")]
	public event UpDownEventHandler UpDown;
	public override void DownButton() {
		UpDownEventArgs e = new UpDownEventArgs(false);
		if (UpDown != null)
			UpDown(this, e);
		if (!e.Handled)
			base.DownButton();
	}
	public override void UpButton() {
		UpDownEventArgs e = new UpDownEventArgs(true);
		if (UpDown != null)
			UpDown(this, e);
		if (!e.Handled)
			base.UpButton();
	}
}
